#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#define ROBOTKILLED 2
#define ROBOTHIT 1
#define PLAYERKILLED 1
#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define TIMESEARCH 10
#define PLAYERRELOADTIME 6000
#define ROBOTRELOADTIME 4000

#define SERVERPORTTOTERMINAL 1380
#define CLIENTPORTFROMTERMINAL 1375
#define IPADDRESS 

#define MINDISTANCE 5
#define MAXDISTANCE 30

void setup(){
  //inizializzo dati
}

int StartPlaying(){
	
	int robot_hit=0; 
	int robot_killed=0;
	int player_hit=0;
	int timer=0;
	int end_timer;
	char buffer[512];
	char messaggio[512]="colpito";

	//start
	while(!player_hit || !robot_killed){
		
	   //strategia di movimento -> distanza dai muri
	   if(!robot_hit){
	      //distanza muro sx
              RoamingNoHit();
	   }
           else{
	      //distanza mnima muro dx
	      RoamingHit();
		}
		/*timer colpito*/
		if(read(socket_serverFunction, buffer, sizeof(buffer))==messaggio){
			robot_hit ++;
			if(robot_hit==ROBOTKILLED){
				robot_killed=1;
			}
			else{
				timer=time();
				do{
					 end_timer=time();
				}while(difftime(end_timer,timer)<ROBOTRELOADTIME);
			}
		}
//		if(wiiuse_poll(wiimote,WIIMOTENUMBER) && !player_hit && !robot_killed){
//			switch(wiimote.event){
//				/*sparo*/
//				case WIIUSE_EVENT: if(wiimote.ir.num_dots==2){
//					do{
//						if(wiimote.ir.dot[0].y == wiimote.ir.dot[1].y){
//							player_hit=PLAYERKILLED;
//							SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
//						}
//						else if(wiimote.ir.dot[3].y == wiimote.ir.dot[0].y){
//							player_hit=PLAYERKILLED;
//							SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
//						}
//						else if (wiimote.ir.dot[1].y == wiimote.ir.dot[2].y){
//							player_hit=PLAYERKILLED;
//							SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
//						}
//						else if(wiimote.ir.dot[2].y == wiimote.ir.dot[3].y){
//							player_hit=PLAYERKILLED;
//							SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
//						}
//					}while(wiimote.ir.num_dots==2 || player_hit);
//				}
//				break;
//
//				default: break;
//			}
//		}
	}
//ChiudiSocket(descrittore_socket_clientFunction);
ChiudiSocket(descrittore_socket_serverFunction);	
return 0;
}

void ChiudiSocket(int sock)
{
  close(sock);
  return;
}

int CreaSocketClient(char* Destinazione, int Porta)
{
  struct sockaddr_in temp; 
  struct hostent *h;
  int sock;
  int errore;
  
  //Tipo di indirizzo
  temp.sin_family=AF_INET;
  temp.sin_port=htons(Porta);
  h=gethostbyname(Destinazione);
  if (h==0) 
  {
    printf("Gethostbyname fallito\n");
    exit(1);
  }
  //Il socket deve essere non bloccante
  errore=fcntl(sock,F_SETFL,O_NONBLOCK);
  
  bcopy(h->h_addr,&temp.sin_addr,h->h_length);
  //Creazione socket. 
  sock=socket(AF_INET,SOCK_STREAM,0);
  //Connessione del socket. Esaminare errore per compiere azioni
  //opportune in caso di errore.
  errore=connect(sock, (struct sockaddr*) &temp, sizeof(temp));
  return sock;
}

int CreaSocketServer(int Porta)
{
  int sock,errore;
  struct sockaddr_in temp;

  //Creazione socket
  sock=socket(AF_INET,SOCK_STREAM,0);
  //Tipo di indirizzo
  temp.sin_family=AF_INET;
  temp.sin_addr.s_addr=INADDR_ANY;
  temp.sin_port=htons(Porta);

  //Il socket deve essere non bloccante
  errore=fcntl(sock,F_SETFL,O_NONBLOCK);

  //Bind del socket
  errore=bind(sock,(struct sockaddr*) &temp,sizeof(temp));
 
  return sock;
}

void SpedisciMessaggio(int sock, char* Messaggio)
{
  //write(socket, messaggio, lunghezza messaggio)
  if (write(sock,Messaggio,strlen(Messaggio))<0)
  {
    printf("Impossibile mandare il messaggio.\n");
    ChiudiSocket(sock);
    exit(1);
  }  
  return;
}

