#define MINDISTANCE 5
#define MAXDISTANCE 30
#define FRONTMAXDISTANCE 35
#define FRONTMINDISTANCE 25
#define LOWMOVE 25
#define MEDIUMMOVE 50
#define HIGHMOVE 100

//politica non colpito: 
//viaggio rasente al murio di sinistra, alla minima distanza possibile
void StartRoaming(int sensorPinDx, int sensorPinSx, int sensorPinFront){

  int distanceRight = effectiveDistance(sensorPinDx);
  int distanceLeft = effectiveDistance(sensorPinSx);
  int distanceFront = effectiveDistance(sensorPinFront);
  
  if(distanceFront>MAXDISTANCE){
    advance(HIGHMOVE, HIGHMOVE);
  }
  
  if(distanceLeft > MINDISTANCE){
    turn_L(LOWMOVE,LOWMOVE);
    advance(MEDIUMMOVE,MEDIUMMOVE);
  }else if (distanceLeft < MINDISTANCE){
          turn_R(LOWMOVE,LOWMOVE); 
          advance(MEDIUMMOVE,MEDIUMMOVE);      
  }
  
  //incrocio: muro di fronte e dx libera
  if(distanceFront<FRONTMAXDISTANCE && distanceRight>MAXDISTANCE){
   turn_R(MEDIUMMOVE,MEDIUMMOVE);
   advance(HIGHMOVE,HIGHMOVE); 
  }else if(distanceFront<FRONTMAXDISTANCE && distanceLeft>MAXDISTANCE){
    //sinistra libera
    turn_L(MEDIUMMOVE,MEDIUMMOVE);
    advance(HIGHMOVE,HIGHMOVE);
  }else if(distanceFront<FRONTMINDISTANCE){
   stop();
  back_off(LOWMOVE,LOWMOVE);
  }
}

//politica colpito: 
//viaggio rasente al murio di destra, alla minima distanza possibile

void RoamingHit(int sensorPinDx, int sensorPinSx, int sensorPinFront){

  int distanceRight = distanceIndex(sensorPinDx);
  int distanceLeft = distanceIndex(sensorPinSx);
  int distanceFront = distanceIndex(sensorPinFront);
  
  if(distanceFront>MAXDISTANCE){
    advance(HIGHMOVE, HIGHMOVE);
  }
  
  if(distanceRight > MINDISTANCE){
    turn_R(LOWMOVE,LOWMOVE);
    advance(MEDIUMMOVE,MEDIUMMOVE);
  }else if (distanceRight < MINDISTANCE){
          turn_L(LOWMOVE,LOWMOVE);
          advance(MEDIUMMOVE,MEDIUMMOVE);       
  }
  
  //incrocio: muro di fronte e dx libera
  if(distanceFront<FRONTMAXDISTANCE && distanceRight>MAXDISTANCE){
   turn_R(MEDIUMMOVE,MEDIUMMOVE);
   advance(HIGHMOVE,HIGHMOVE); 
  }else if(distanceFront<FRONTMAXDISTANCE && distanceLeft>MAXDISTANCE){
    //sinistra libera
    turn_L(MEDIUMMOVE,MEDIUMMOVE);
    advance(HIGHMOVE,HIGHMOVE);
  }else if(distanceFront<FRONTMINDISTANCE){
   stop();
   back_off(LOWMOVE,LOWMOVE);
  }
  
  
}




