  /*
   Aggiornato per motor controller TB6612FMB
  */
  const int SPSX = 3;
  const int D1SX = 8;
  const int D2SX = 9;
  
  const int SPDX = 5;
  const int D1DX = 12;
  const int D2DX = 11;
  
  const int STBY = 10;     
  
  void initMotor(){
    // init motors
    pinMode(SPSX, OUTPUT);
    pinMode(SPDX, OUTPUT);
    pinMode(D1SX, OUTPUT);
    pinMode(D2SX, OUTPUT);
    pinMode(D1DX, OUTPUT);
    pinMode(D2DX, OUTPUT);
    pinMode(STBY, OUTPUT); 
    
  }
    
  void stop(void)                    //Stop
  {
    digitalWrite(STBY, LOW);    
  } 
  
  void start(void){                  //Abilita motori
   digitalWrite(STBY, HIGH); 
  }
    
  void advance(char a,char b)          //Move forward
  {
    analogWrite (SPDX,a);
    digitalWrite(D1DX,HIGH);
    digitalWrite(D2DX,LOW);    
    analogWrite (SPSX,b);    
    digitalWrite(D1SX,HIGH);
    digitalWrite(D2SX,LOW);
  }
  
  void back_off (char a,char b)          //Move backward
  {
    analogWrite (SPDX,a);
    digitalWrite(D1DX,LOW);
    digitalWrite(D2DX,HIGH);    
    analogWrite (SPSX,b);    
    digitalWrite(D1SX,LOW);
    digitalWrite(D2SX,HIGH);
  }
  void turn_L (char a,char b)             //Turn Left OK!!!
  {
    analogWrite (SPDX,a);
    digitalWrite(D1DX,HIGH);
    digitalWrite(D2DX,LOW);    
    analogWrite (SPSX,b);    
    digitalWrite(D1SX,LOW);
    digitalWrite(D2SX,HIGH);
  }
  void turn_R (char a,char b)             //Turn Right
  {
    analogWrite (SPDX,a);
    digitalWrite(D1DX,LOW);
    digitalWrite(D2DX,HIGH);    
    analogWrite (SPSX,b);    
    digitalWrite(D1SX,HIGH);
    digitalWrite(D2SX,LOW);
  }
   
  
    

