  #define MINDISTANCE 5
  #define MAXDISTANCE 35
  #define FRONTMAXDISTANCE 15
  #define FRONTMINDISTANCE 5
  #define LOWMOVE 25
  #define MEDIUMMOVE 50
  #define HIGHMOVE 100
  #define ERRORDISTANCE 45
  
  #define SENSORPINLEFT 0
  #define SENSORPINFRONT 1
  #define SENSORPINRIGHT 2
  
    
  void RoamingProva(){
    
    const int sensorRightPin = SENSORPINRIGHT;
    const int sensorLeftPin = SENSORPINLEFT;
    const int sensorFrontPin = SENSORPINFRONT;
    
    int distanceRight = effectiveDistance(sensorRightPin);
    int distanceLeft = effectiveDistance(sensorLeftPin);
    int distanceFront = effectiveDistance(sensorFrontPin);
    Serial.print("Distanza destra: ");
    Serial.println(distanceRight);
    Serial.print("Distanza sinistra: ");
    Serial.println(distanceLeft);
    Serial.print("Distanza davanti: ");
    Serial.println(distanceFront);
    
    
    if(distanceFront>FRONTMAXDISTANCE ){
      Serial.println("Niente davanti, avanzo ");
      start();
      //Abilito i motori
      advance(MEDIUMMOVE, MEDIUMMOVE);
      //Avanzo x 3 secondi
      delay(2000);
      stop();
      //aggiorno i sensori
      distanceRight = effectiveDistance(sensorRightPin);
      distanceLeft = effectiveDistance(sensorLeftPin);
      distanceFront = effectiveDistance(sensorFrontPin);
      Serial.print("Distanza destra: ");
    Serial.println(distanceRight);
    Serial.print("Distanza sinistra: ");
    Serial.println(distanceLeft);
    Serial.print("Distanza davanti: ");
    Serial.println(distanceFront);
      delay(1000);
      
    }
    else if(distanceFront < FRONTMAXDISTANCE){
      Serial.println("Qualcosa davanti, valuto... ");
      if(distanceLeft > MAXDISTANCE){
        Serial.println("Libero a sinistra, giro a sinistra");
        start();
        turn_L(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        stop();
        //aggiorno i sensori
        distanceRight = effectiveDistance(sensorRightPin);
        distanceLeft = effectiveDistance(sensorLeftPin);
        distanceFront = effectiveDistance(sensorFrontPin);
        Serial.print("Distanza destra: ");
    Serial.println(distanceRight);
    Serial.print("Distanza sinistra: ");
    Serial.println(distanceLeft);
    Serial.print("Distanza davanti: ");
    Serial.println(distanceFront);
        delay(1000);
      }  
      else if(distanceRight > MAXDISTANCE){
        Serial.println("libero a destra, giro a destra");
        start();
        turn_R(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        stop();
        //aggiorno i sensori
        distanceRight = effectiveDistance(sensorRightPin);
        distanceLeft = effectiveDistance(sensorLeftPin);
        distanceFront = effectiveDistance(sensorFrontPin);
        Serial.print("Distanza destra: ");
    Serial.println(distanceRight);
    Serial.print("Distanza sinistra: ");
    Serial.println(distanceLeft);
    Serial.print("Distanza davanti: ");
    Serial.println(distanceFront);
        delay(1000);
      } else if(distanceFront < FRONTMINDISTANCE){
        Serial.println("Troppo vicino, indietreggio");
      start();
      back_off(MEDIUMMOVE, MEDIUMMOVE);
      delay(2000);
      stop();
      //aggiorno i sensori
      distanceRight = effectiveDistance(sensorRightPin);
      distanceLeft = effectiveDistance(sensorLeftPin);
      distanceFront = effectiveDistance(sensorFrontPin);
      Serial.print("Distanza destra: ");
    Serial.println(distanceRight);
    Serial.print("Distanza sinistra: ");
    Serial.println(distanceLeft);
    Serial.print("Distanza davanti: ");
    Serial.println(distanceFront);
      delay(1000);
      }
    }           
     
  }  
  
  
  void RoamingProva2(){
    
    const int sensorRightPin = SENSORPINRIGHT;
    const int sensorLeftPin = SENSORPINLEFT;
    const int sensorFrontPin = SENSORPINFRONT;
    
    int distanceRight = effectiveDistance(sensorRightPin);
    int distanceLeft = effectiveDistance(sensorLeftPin);
    int distanceFront = effectiveDistance(sensorFrontPin);
    
    
    
    if(distanceFront>FRONTMAXDISTANCE ){
      Serial.println("Niente davanti, avanzo ");
      start();
      //Abilito i motori
      advance(MEDIUMMOVE, MEDIUMMOVE);
      //Avanzo x 3 secondi
      delay(2000);
      stop();
      //aggiorno i sensori
      distanceRight = effectiveDistance(sensorRightPin);
      distanceLeft = effectiveDistance(sensorLeftPin);
      distanceFront = effectiveDistance(sensorFrontPin);
     
      delay(1000);
      
    }
    if(distanceFront < FRONTMAXDISTANCE){
      Serial.println("Qualcosa davanti, valuto... ");
      if(distanceLeft > MAXDISTANCE){
        Serial.println("Libero a sinistra, giro a sinistra");
        start();
        turn_L(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        advance(LOWMOVE, LOWMOVE);
        delay(3000);
        stop();
        //aggiorno i sensori
        distanceRight = effectiveDistance(sensorRightPin);
        distanceLeft = effectiveDistance(sensorLeftPin);
        distanceFront = effectiveDistance(sensorFrontPin);
      
        delay(1000);
      }  
      else if(distanceRight > MAXDISTANCE){
        Serial.println("libero a destra, giro a destra");
        start();
        turn_R(MEDIUMMOVE, MEDIUMMOVE);
        delay(2000);
        advance(LOWMOVE, LOWMOVE);
        delay(3000);
        stop();
        //aggiorno i sensori
        distanceRight = effectiveDistance(sensorRightPin);
        distanceLeft = effectiveDistance(sensorLeftPin);
        distanceFront = effectiveDistance(sensorFrontPin);
        
        delay(1000);
      } 
    }
    if(distanceFront < FRONTMINDISTANCE){
        Serial.println("Troppo vicino, indietreggio");
      start();
      back_off(LOWMOVE, LOWMOVE);
      delay(3000);
      stop();
      //aggiorno i sensori
      distanceRight = effectiveDistance(sensorRightPin);
      distanceLeft = effectiveDistance(sensorLeftPin);
      distanceFront = effectiveDistance(sensorFrontPin);
      
      delay(1000);
      }    
     
  }
