//  #define MIN 5
//  #define MAX 10
//  #define FRONTMAX 25
//  #define FRONTMIN 15
//  #define LOWMOVE 25
//  #define MEDIUMMOVE 50
//  #define HIGHMOVE 100
//  #define ERRORDISTANCE 45
//  
//  #define SENSORPINLEFT 0
//  #define SENSORPINFRONT 1
//  #define SENSORPINRIGHT 2
//  

    #define MIN 10  
    #define MAX 25
    #define FRONTMAX 20 //15
    #define FRONTMIN 5
    #define LOWMOVE 25
    #define MEDIUMMOVE 50
    #define HIGHMOVE 100
    #define ERRORDISTANCE 45
    #define DELAY 500          //ritardo tra le azioni
    
     const int sensorRightPin = 2;
    const int sensorLeftPin = 0;
    const int sensorFrontPin = 1;
    
    int right;
    int left;
    int front;
    
  //politica movimento base, tempi veloci di reazione, tocca ancora qualche muro...  
  void RoamingBase(){
    
//    aggiornoDistanze();
 
    right = effectiveDistance(sensorRightPin);
 
    left = effectiveDistance(sensorLeftPin);
 
    front = effectiveDistance(sensorFrontPin);
 
    
    if(front > FRONTMIN ){
      if(front > FRONTMAX){
//        xBee.print("Avanzo \n");
        start();
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(3000);
        stop();
            
      }
      
      else if(front <= FRONTMAX){
        if(right > MAX ){
            
//            xBee.print("Giro tanto a destra \n");
            start();
            turn_R(MEDIUMMOVE,MEDIUMMOVE);
            delay(3000);
            advance(LOWMOVE,LOWMOVE);
            delay(1000);
            stop();
            
          }
          
        else if(left > MAX){
             
//              xBee.print("Giro tanto a sinistra \n");
              start();
              turn_L(MEDIUMMOVE,MEDIUMMOVE);
              delay(3000);
              advance(LOWMOVE,LOWMOVE);
              delay(1000);
              stop();
              
        }
        else{
         if(right > MIN){ 
//         xBee.print("Giro poco a destra \n");
         start();
         turn_R(MEDIUMMOVE,MEDIUMMOVE);
         delay(1000);
         stop();
         }
         else if (left > MIN){
           start();
//           xBee.print("Giro tanto a sinistra \n");
           turn_L(MEDIUMMOVE,MEDIUMMOVE);
           delay(1000);
           stop();
         }
        }
          
       
        
        
      }      
    }
    if(front <= FRONTMIN){
//      xBee.print("Indietreggio \n");
      start();
      back_off(LOWMOVE, LOWMOVE);
      delay(3000);
      stop();
      
      
    }
    
  }
  
//politica movimento non colpito, rallentata x permettere visibilità dei led

void RoamingSlow(){
    
    //calcolo distanze
    right = effectiveDistance(sensorRightPin);
    left = effectiveDistance(sensorLeftPin);
    front = effectiveDistance(sensorFrontPin);
 
     if(front > FRONTMIN ){
      if(front > FRONTMAX){
//        xBee.print("Avanzo \n");
        start();
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(3000);
        stop();
        delay(DELAY);    
      }
      
      else if(front <= FRONTMAX){
        if(right > MAX ){
            
//            xBee.print("Giro tanto a destra \n");
            start();
            turn_R(HIGHMOVE,HIGHMOVE);
            delay(2000);
            advance(MEDIUMMOVE,MEDIUMMOVE);
            delay(2000);
            stop();
            delay(DELAY);
          }
          
        else if(left > MAX){
             
//              xBee.print("Giro tanto a sinistra \n");
              start();
              turn_L(HIGHMOVE,HIGHMOVE);
              delay(2000);
              advance(MEDIUMMOVE,MEDIUMMOVE);
              delay(2000);
              stop();
              delay(DELAY);
        }
        else{
         if(left > MIN){ 
//         xBee.print("Giro poco a destra \n");
         start();
         turn_L(MEDIUMMOVE,MEDIUMMOVE);
         delay(2000);
         stop();
         delay(DELAY);
         }
         else if (right > MIN){
           start();
//           xBee.print("Giro tanto a sinistra \n");
           turn_R(MEDIUMMOVE,MEDIUMMOVE);
           delay(2000);
           stop();
           delay(DELAY);
         }
        }
          
       
        
        
      }      
    }
    if(front <= FRONTMIN){
//      xBee.print("Indietreggio \n");
      start();
      back_off(LOWMOVE, LOWMOVE);
      delay(3000);
      stop();
      delay(DELAY);
      
    }
    
    
  }

//politica movimento lento quando colpito, inverte la scelta della direzione tra dx e sx
void RoamingSlowHit(){
    
    //calcolo distanze
    right = effectiveDistance(sensorRightPin);
    left = effectiveDistance(sensorLeftPin);
    front = effectiveDistance(sensorFrontPin);
 
     if(front > FRONTMIN ){
      if(front > FRONTMAX){
//        xBee.print("Avanzo \n");
        start();
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(3000);
        stop();
        delay(DELAY);    
      }
      
      else if(front <= FRONTMAX){
        if(left > MAX ){
            
//            xBee.print("Giro tanto a destra \n");
            start();
            turn_L(HIGHMOVE,HIGHMOVE);
            delay(2000);
            advance(MEDIUMMOVE,MEDIUMMOVE);
            delay(2000);
            stop();
            delay(DELAY);
          }
          
        else if(right > MAX){
             
//              xBee.print("Giro tanto a sinistra \n");
              start();
              turn_R(HIGHMOVE,HIGHMOVE);
              delay(2000);
              advance(MEDIUMMOVE,MEDIUMMOVE);
              delay(2000);
              stop();
              delay(DELAY);
        }
        else{
         if(right > MIN){ 
//         xBee.print("Giro poco a destra \n");
         start();
         turn_R(MEDIUMMOVE,MEDIUMMOVE);
         delay(2000);
         stop();
         delay(DELAY);
         }
         else if (left > MIN){
           start();
//           xBee.print("Giro tanto a sinistra \n");
           turn_L(MEDIUMMOVE,MEDIUMMOVE);
           delay(2000);
           stop();
           delay(DELAY);
         }
        }
          
       
        
        
      }      
    }
    if(front <= FRONTMIN){
//      xBee.print("Indietreggio \n");
      start();
      back_off(LOWMOVE, LOWMOVE);
      delay(3000);
      stop();
      delay(DELAY);
      
    }
    
    
    
  }


//mi giro quando sono colpito  

  void turn_Around(){
    start();
    turn_R(HIGHMOVE,HIGHMOVE);
    delay(4000);
    stop();
    delay(DELAY);                            /* mi fermo x permettere di essere colpito */    
  }

//mi giro in caduta quando muoio

  void turn_Down(){
   start();
   turn_L(HIGHMOVE,HIGHMOVE);
   delay(6000);
   stop();
  }
  
//controllo funzionamento motori
    void RoamingDude(){
     
     start();
     back_off(LOWMOVE,LOWMOVE);
     delay(3000);
     
     stop();
    }
