#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <ncurses.h>
#include <string.h>

    #include <termios.h>
    #include <unistd.h>
    #include <fcntl.h>
    #include <errno.h>   /* Error number definitions */
    
    
int open_port();
int scriviSeriale(int fd);
int settingSeriale();

int main (int argc, char * argv []){
	char invio;
	//inizializzo seriale
	int seriale = settingSeriale();
	printf("Idenitficativo porta seriale: %d \n", seriale);
	do{
		//xbee invio ferma robot
		scanf("%*c");
		int trasmesso = scriviSeriale(seriale);
		printf("Trasmessi %d bytes \n", trasmesso);
		printf("Premi s per inviare di nuovo, un carattere qualsiasi per uscire: ");
		scanf("%c", &invio);
	}while(invio == 's');
	return 0;
}
			
int settingSeriale(){
	struct termios options;
	int fd;
	//apro porta
	fd = open_port();
	//setting porta
	tcgetattr(fd, &options);
	
	/*baudrate*/
	cfsetispeed(&options, B9600);
	cfsetospeed(&options, B9600);
	options.c_cflag |= (CLOCAL | CREAD);
	/*character size*/
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	/*parity check*/
	options.c_cflag &= ~PARENB;
	options.c_cflag &= ~CSTOPB;
	/*canonical input*/
	options.c_lflag |= (ICANON | ECHO | ECHOE);
	/*processed output*/
	options.c_oflag |= OPOST;
	
	tcsetattr(fd, TCSANOW, &options);
	return fd;
}

int scriviSeriale(int fd){
	//scrivo carattere
	int n = write(fd, "1", 1);
	if (n < 0){
		fputs("write() of 1 bytes failed!\n", stderr);
	}
	return n;
}

int open_port(){
  int fd; /* File descriptor for the port */
  fd = open("/dev/ttyUSB0", O_RDWR | O_NOCTTY | O_NDELAY);
  if (fd == -1){
  	// Could not open the port
  	perror("open_port: Unable to open /dev/ttyUSB0 - ");
  }
  else{
    fcntl(fd, F_SETFL, 0);
  }
  return (fd);
}

