#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const int E1 = 5;     //M1 Speed Control
const int E2 = 6;     //M2 Speed Control
const int E3 = 	;     //M3 Speed Control
const int E4 =  ;     //M4 Speed Control
const int M1 = 4;     //M1 Direction Control
const int M2 = 7;     //M2 Direction Control
const int M3 =  ;     //M3 Direction Control
const int M4 =  ;     //M4 Direction Control

void initMotor(){
  // init motors
  int i;
  for(i=4;i<=7;i++)
    pinMode(i, OUTPUT);  
    
  // init pins
  digitalWrite(E1,LOW);   
  digitalWrite(E2,LOW); 
}

void stop(void)                    //Stop
{
  digitalWrite(E1,0); 
  digitalWrite(M1,LOW);    
  digitalWrite(E2,0);   
  digitalWrite(M2,LOW);    
}   
void advance(char a,char b)          //Move forward
{
  analogWrite (E1,a);
  digitalWrite(M1,HIGH);    
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
}  
void back_off (char a,char b)          //Move backward
{
  analogWrite (E1,a);
  digitalWrite(M1,LOW);    
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
}
void turn_L (char a,char b)             //Turn Left
{
  analogWrite (E1,a);      //PWM Speed Control
  digitalWrite(M1,HIGH);    
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
}
void turn_R (char a,char b)             //Turn Right
{
  analogWrite (E1,a);
  digitalWrite(M1,LOW);   
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
}