#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define SEARCHTIME 10

int main (int argc, char* argv []){

	int number_of_wiimote=0;
	int connected=0;
	wiimote** wiimote_player;
	wiimote** wiimote_robot;

	//inizializzazione wiimote_player
	wiimote_player=wiiuse_init(WIIMOTENUMBER);
	printf("inizializzazione wiimote_player...\n");
	number_of_wiimote=wiiuse_find(wiimote_player, WIIMOTENUMBER, SEARCHTIME);
	printf("numero di wiimote trovati: %i \n", number_of_wiimote);
	connected=wiiuse_os_connect(wiimote_player,WIIMOTENUMBER);
	if(connected){
		printf("Connesso a %i wiimote_player di %i trovati.\n",connected, number_of_wiimote);	//modifico puntatore
	}else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}

	/* il player come si connette al wiimote?
	se indirzzo non univoco devo mandare id come x robot...
	*/

	//inizializzazione wiimote_robot
	wiimote_robot=wiiuse_init(WIIMOTENUMBER);
	printf("inizializzazione wiimote_robot...\n");
	number_of_wiimote=wiiuse_find(wiimote_robot, WIIMOTENUMBER, SEARCHTIME);
	printf("numero di wiimote trovati: %i\n", number_of_wiimote);
	connected=wiiuse_os_connect(wiimote_robot,WIIMOTENUMBER);
	if(connected){
		printf("Connesso a %i wiimote_robot di %i trovati.\n",connected, number_of_wiimote);
	}else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}

	return 0;
}
