  #include <Arduino.h>
  #include <SoftwareSerial.h>
  
  #define ROBOTRELOAD 3000
  
  const int rxPin = 6;
  const int txPin = 7;
  SoftwareSerial xBee = SoftwareSerial(rxPin,txPin);
  int colpito = 2;
  int value;
  int exitValue =0;
  
  
  void setup(){
    
    Serial.begin(9600);
    initMotor();
    initLED();
    pinMode(rxPin, INPUT);
    pinMode(txPin, OUTPUT);
    xBee.begin(9600);
    
  }
  
  void loop(){    
    accensioneLED();    
    do{
      
      //politica non colpito
      if(colpito == 0){
        do{
//          StartRoaming();
            RoamingProva();
            if(xBee.available() && colpito == 0 && exitValue == 0){
              value = xBee.read();
              if(value == 1){
                colpito = 1;
                stop();
                delay(ROBOTRELOAD);
              }
            }  
        }while(colpito == 0);
      }
      //politica colpito
      else{
        do{
//          RoamingHit();
            if(xBee.available() && colpito == 1 && exitValue == 0){
              value = xBee.read();
              if(value == 1){
                stop();
                exitValue = 1;
                colpito = 2; 
              }
            }
        }while(colpito == 1);  
      }  
      
    }while(exitValue == 0);  
    stop();
    spegnimentoLED();
}
