  #include <Arduino.h>
  #include <SoftwareSerial.h>
  
  #define MIN 10
  #define MAX 25
  #define FRONTMAX 15
  #define FRONTMIN 5
  #define LOWMOVE 25
  #define MEDIUMMOVE 50
  #define HIGHMOVE 100
  #define ERRORDISTANCE 45

  #define ROBOTRELOAD 3000
  
  const int rxPin = 6;
  const int txPin = 7;
  SoftwareSerial xBee = SoftwareSerial(rxPin,txPin);
  int colpito = 0;
  int value;
  int exitValue =0;
  
  
  
  void setup(){
    
    Serial.begin(9600);
    initMotor();
    initLED();
    pinMode(rxPin, INPUT);
    pinMode(txPin, OUTPUT);
    xBee.begin(9600);
    
  }
  
  void loop(){    
    accensioneLED(); 
    do{   
      while(colpito == 0){
      
      //politica non colpito
        
          xBee.print("Abilito motori \n");
          start();
          xBee.print("Politica non colpito\n");
          RoamingBase();
          
          if(exitValue == 0){
            value=xBee.read();
            switch(value){
              case '1': xBee.print("Colpito! ");
                        colpito = 1;
                        stop();
                        xBee.print("Attendo... ");
                        delay(ROBOTRELOAD);
                        xBee.print("..riparto! \n"); 
                        break;
              //roaming
              default: xBee.println("Nessun segnale via XBee..");
                        
                       break;
            }      
          }
          xBee.print("Disabilito motori \n");
          stop();
          delay(1000);
//          RoamingBase();
       }
      
      //politica colpito
      
        while(colpito == 1){
          xBee.print("Abilito motori \n");
          start();
          xBee.print("Politica Colpito \n");
           RoamingBase();
           
           if(exitValue == 0){
            value=xBee.read();
            switch(value){
              case '1': xBee.print("Morto \n");
                        stop();
                        exitValue = 1;
                        colpito = 2;
                         delay(ROBOTRELOAD);
                        break;
              //roaming
              default: xBee.println("Nessun segnale via XBee..");
                       
                       break;
            }      
          } 
          xBee.print("Disabilito motori \n");
          stop();
          delay(1000);
        }  
        
      
    }while(exitValue == 0);
    while(colpito == 2 && exitValue == 1){
      xBee.print("Dead robots don't walk anymore... \n");
      stop();
      spegnimentoLED();
    }
}



