#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>


#define ROBOTKILLED 2
#define PLAYERKILLED 1
#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define SEARCHTIME 10
#define PLAYERRELOADTIME 6000
#define ROBOTRELOADTIME 4000

#define CLIENTPORTTOROBOT 1380
#define SERVERPORTFROMROBOT 1375
#define SERVERPORTFROMPLAYER 1376
#define IPADDRESS 

int CreaSocketServer(int);
void SpedisciMessaggio(int , char*);
int CreaSocketClient(char*, int);
void ChiudiSocket(int);

int main (int argc, char * argv []){
	
	clock_t timer;
	clock_t end_timer;
	int shot_permitted=0;
	int player_killed=0;
	int robot_killed=0;
	int robot_hit=0;
	char playername [20];
	char answer;
	int number_of_wiimote=0;
	int connected;
	wiimote** wiimote_player;
	wiimote** wiimote_robot;
//	int descrittore_socket_serverFunction;
	int descrittore_socket_clientFunction;
	int descrittore_socket_player;
	int robot_socket;
	int player_socket;
	char buffer[512];
	char messaggio[512]="colpito";
	
	//inizializzazione wiimote_player
	wiimote_player=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_player, WIIMOTENUMBER, SEARCHTIME);
	connected=wiiuse_connect(wiimote_player,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_player di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}
	
	/* il player come si connette al wiimote? 
	se indirzzo non univoco devo mandare id come x robot...
	*/
	
	//inizializzazione wiimote_robot
	wiimote_robot=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_robot, WIIMOTENUMBER, SEARCHTIME);
	connected=wiiuse_connect(wiimote_robot,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_robot di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}
/*	//connessione al robot mediante socket, funzionalit server
	//socket non bloccante
	descrittore_socket_serverFunction=CreaSocketServer(SERVERPORTFROMROBOT); Robot programmato
	if(descrittore_socket_serverFunction==-1){
		printf("Errore connessione socket robot, funzione server");
	}*/
	/*connessione al robot tramite socket, funzionalit client 
	descrittore_socket_clientFunction=CreaSocketClient("IPADDRESS",CLIENTPORTTOROBOT);
*/	
/*	invio id wiimote robot x connessione
	int id_robot=wiimote_robot.unid;
	SpedisciMessaggio(descrittore_socket_clientFunction,(char)id_robot);*/
	
/*	//connessione al player tramite socket, funzionalit server
	//socket non bloccante
	descrittore_socket_player=CreaSocketServer(SERVERPORTFROMPLAYER); 
	if(descrittore_socket_player==-1){
		printf("Errore connessione socket");
	}
*/
	//richiesta inizio gioco
	printf("Vuoi giocare a Laser Game Bot? s/n");
	scanf(" %c", &answer);
	if(answer == 'n'){
		return 0;
	}
	printf("Benvenuto Giocatore!\n Inserisci il tuo nome:");
	
	gets(playername);
	printf("Benvenuto %s \n", playername);
	
	// spiegazione del gioco e comandi
	printf("il gioco consiste nel riuscire a colpire 2 volte il robot avverasrio, senza però essere colpiti da questo. Se vieni colpito anche una sola volta hai perso. Ogni volta che spari la tua arma ha un tempo di ricarica, quidni dovrai aspettare prima di poter sparare dio nuovo. quando il tuo avversario vioene colpito, rimarrà in standby per un certo tempo, così avrai tempo di fuggire. \n I comandi sono...\n");
	
	//inizio gioco
	printf("Che la sfida cominci!");
	shot_permitted=1;
	while(robot_hit<ROBOTKILLED || !player_killed){
		
		//metto in attesa di info via socket da robot e player
//		robot_socket=accept(descrittore_socket_serverFunction,0,0);
//		player_socket=accept(descrittore_socket_player,0,0);
		
		//polling eventi da wiimote_player
		printf("in attesa da seganle wiimote...");
		if(wiiuse_poll(wiimote_player,1) || wiiuse_poll(wiimote_robot,1)){
		
		//ipotesi: giocatore x sparare usa pulsante B
			
				/*giocatore spara ma non colpisce il robot*/
				if(IS_JUST_PRESSED((*wiimote_player), WIIMOTE_BUTTON_B) && shot_permitted 
				&& !confermacolpo(wiimote_player)){
					/*condizione ricarica arma player*/
					shot_permitted=0;
					printf("Bersaglio mancato");
					timer=clock();
					printf("Attendi ricarica arma.. \n");
					do{
						end_timer=clock();
					}while((end_timer-timer)<PLAYERRELOADTIME);
					shot_permitted=1;
					printf("..Ricarica completata \n");
				}
				
				/*giocatore spara e colpisce robot*/
				if(IS_JUST_PRESSED((*wiimote_player), WIIMOTE_BUTTON_B) && shot_permitted && confermacolpo(wiimote_player)){
					/*condizione ricarica robot se colpito*/
					SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
					robot_hit++;
                    shot_permitted=0;
					printf("Hai colpito il tuo avversario %d volte", robot_hit);
                    printf("Attendi ricarica arma.. \n");
					if(robot_hit==ROBOTKILLED){
						robot_killed=1;
					}
                    //info su tempo ricarica avversario
					else{
						timer=clock();
						do{
							end_timer=clock();
                            if(end_timer==PLAYERRELOADTIME){
                                shot_permitted=1;
                                printf("..Ricarica completata \n");
                            }
						}while((end_timer-timer)<ROBOTRELOADTIME);
						printf("Il tuo avversario è ripartito. \n");	
					}		
				}
				
				/*player colpito*/
				//if(read(descrittore_socket_serverFunction, buffer, sizeof(buffer))==messaggio)
				if(confermacolpo(wiimote_robot)){
					SpedisciMessaggio(descrittore_socket_clientFunction,messaggio);
					player_killed=PLAYERKILLED;
				}
			
		}
		
	}
	//fine del gioco
	if(player_killed){
		printf("%s sei stato colpto, hai perso \n", playername); 
	}
	else{
		if(robot_killed==ROBOTKILLED){
			printf("%s hai distrutto il tuo avversario, hai vinto!!! \n", playername);
		}
	printf("Grazie per aver partecipato!\n");
	wiiuse_cleanup(wiimote_player,ALLWIIMOTE);
//	ChiudiSocket(descrittore_socket_serverFunction);
	ChiudiSocket(descrittore_socket_player);
	ChiudiSocket(descrittore_socket_clientFunction);
	return 0;
	}

}

int confermacolpo(wiimote** wiimote){
	if((**wiimote).ir.num_dots==2){
		if((**wiimote).ir.dot[0].y == (**wiimote).ir.dot[1].y){
			return 1;
		}
		else if((**wiimote).ir.dot[3].y == (**wiimote).ir.dot[0].y){
			return 1;
		}
		else if ((**wiimote).ir.dot[1].y == (**wiimote).ir.dot[2].y){
			return 1;
		}
		else if((**wiimote).ir.dot[2].y == (**wiimote).ir.dot[3].y){
			return 1;
		}
	}
	return 0;
}


int CreaSocketServer(int Porta){
  int sock,errore;
  struct sockaddr_in temp;

  //Creazione socket
  sock=socket(AF_INET,SOCK_STREAM,0);
  //Tipo di indirizzo
  temp.sin_family=AF_INET;
  temp.sin_addr.s_addr=INADDR_ANY;
  temp.sin_port=htons(Porta);

  //Il socket deve essere non bloccante
  errore=fcntl(sock,F_SETFL,O_NONBLOCK);

  //Bind del socket
  errore=bind(sock,(struct sockaddr*) &temp,sizeof(temp));
 
  return sock;
}

void SpedisciMessaggio(int sock, char* Messaggio){
  //write(socket, messaggio, lunghezza messaggio)
  if (write(sock,Messaggio,strlen(Messaggio))<0)
  {
    printf("Impossibile mandare il messaggio.\n");
    ChiudiSocket(sock);
    exit(1);
  }  
  return;
}

int CreaSocketClient(char* Destinazione, int Porta){
  struct sockaddr_in temp; 
  struct hostent *h;
  int sock;
  int errore;
  
  //Tipo di indirizzo
  temp.sin_family=AF_INET;
  temp.sin_port=htons(Porta);
  h=gethostbyname(Destinazione);
  if (h==0) 
  {
    printf("Gethostbyname fallito\n");
    exit(1);
  }
  //Il socket deve essere non bloccante
  errore=fcntl(sock,F_SETFL,O_NONBLOCK);
  
  bcopy(h->h_addr,&temp.sin_addr,h->h_length);
  //Creazione socket. 
  sock=socket(AF_INET,SOCK_STREAM,0);
  //Connessione del socket. Esaminare errore per compiere azioni
  //opportune in caso di errore.
  errore=connect(sock, (struct sockaddr*) &temp, sizeof(temp));
  return sock;
}

void ChiudiSocket(int sock){
  close(sock);
  return;
}

